(function(){
    var kpnsCallback = null;
    var kpnsWatchId = -1;
     
    function kpnsData (message) {
        this.kpnsCallback({'kpns':message});
    }
     
    function kpnsReceived(callback) {
    	// callback이 null이면 kpns 데이터를 가져오는 작업을 중지한다.
    	if(callback == null && kpnsWatchId != -1) {
    		clearInterval(kpnsWatchId);
    		return;
    	}
    	
        this.kpnsCallback = callback;
        
        // iOS이면 더 이상 진행하지 않는다.
        if (/(iPad|iPhone|iPod)/i.test(window.agent)) {
        	return;
        }
	
		var self = this;
		
		var _callback = function() {
			try {
				var json = self.execSync('kpnsReceived');
				if(json) self.kpnsCallback(json);
			} catch(e) {
				console.log(e.message);
			}
		};
		
		kpnsWatchId = setInterval(_callback, 1500);
    }
     
    function register(callback) {
        return this.execAsync('register', callback, ax.nop, [ '' ]);
    }
     
    function unregister(callback) {
        return this.execAsync('unregister', callback, ax.nop, [ '' ]);
    }
     
    function groupRegister(callback, groupcode) {
        if (!groupcode) {
            throw ax.error(ax.INVALID_VALUES_ERR, 'invalid argument!');
        }
        return this.execAsync('groupRegister', callback, ax.nop , [ groupcode||'' ]);
    }
     
    function groupUnregister(callback, groupcode) {
        if (!groupcode) {
            throw ax.error(ax.INVALID_VALUES_ERR, 'invalid argument!');
        }
        return this.execAsync('groupUnregister', callback, ax.nop, [ groupcode||'' ]);
    }
     
    function isItRegist(callback){
        return this.execAsync('isItRegist', callback, ax.nop, [ '' ]);
    }
     
    function setBadgeCount (badgeCount) {
        if (!badgeCount) {
            throw ax.error(ax.INVALID_VALUES_ERR, 'invalid argument!');
        }
        return this.execAsync('setBadgeCount', ax.nop, ax.nop, [ badgeCount||'' ]);
    }
    
    function cancelAll(){
        return this.execAsync('cancelAll', ax.nop, ax.nop, [ '' ]);
    }
 
    window.kpnsPlugin = ax.plugin('com.appspresso.plugin.kpns', {
        'kpnsData':kpnsData,
        'kpnsReceived':kpnsReceived,
        'register':register,
        'unregister':unregister,
        'groupRegister':groupRegister,
        'groupUnregister':groupUnregister,
        'isItRegist':isItRegist,
        'setBadgeCount':setBadgeCount,
        'cancelAll': cancelAll
    },'com.appspresso.plugin.kpns');
})();