/*
 * JavaScript Stub Appspresso Plugin
 * 
 * id: com.example.ax.echo
 * version: 1.0.0
 * feature: <feature id="" category="Custom" />
 */

(function(){
	
	var onCaptureImageCallback = undefined;
	function onCaptureImage(result) {    
		if (onCaptureImageCallback) {
			onCaptureImageCallback.call(this, result);
			onCaptureImageCallback = undefined;
		}
	}
	
	var onCaptureImageErrorCallback = undefined;
	function onCaptureErrorImage(result) {    
		if (onCaptureImageErrorCallback) {
			onCaptureImageErrorCallback.call(this, result);
			onCaptureImageErrorCallback = undefined;
		}
	}

	function echoSync(message) {
		if(!message) {
			throw ax.error(ax.INVALID_VALUES_ERR, 'invalid argument!');
		}
		return this.execSync('echo', [ message||'' ]);
	}

	function captureImage(callback, errback, opt) {		
		onCaptureImageCallback = callback;
		onCaptureImageErrorCallback = errback;
		
		this.execAsync('captureImage', ax.nop, errback, [ opt ]);
	}
	
	function findFace(callback, errback, message) {
		onCaptureImageCallback = callback;
		onCaptureImageErrorCallback = errback;
		
		this.execAsync('findFace', ax.nop, errback, [ message||'' ]);
	}

	window.puddingface = ax.plugin('com.kth.plugin.puddingface', {
		'captureImage': captureImage,
		'findFace': findFace,
		'onCaptureImage': onCaptureImage,
		'onCaptureErrorImage': onCaptureErrorImage
	});
})();
